#include <system/api.h>

#include "kmenu.h"

//#define DYNAMIC_LOAD

#ifdef DYNAMIC_LOAD
void (*kmenu_init)(t_system_colors *colors);
ksubmenu_t * (*ksubmenu_new)(void);
void (*ksubmenu_delete)(ksubmenu_t *menu);
int (*ksubmenu_draw)(ksubmenu_t *menu, t_point *pt, int level);
void (*ksubmenu_add)(ksubmenu_t *menu, kmenuitem_t *menuitem);
kmenuitem_t * (*kmenuitem_new)(int type, char *text, void *data);
void (*kmenuitem_delete)(kmenuitem_t *item);
void (*kmenuitem_draw)(kmenuitem_t *item, t_rect *rc);
size_t (*kmenuitem_get_preffered_width)(kmenuitem_t *item);
size_t (*kmenuitem_get_preffered_height)(kmenuitem_t *item);
#endif

t_system_colors theme = {0};

ksubmenu_t *menu = NULL, *submenu1 = NULL, *submenu2 = NULL;

ksubmenu_t *main_menu = NULL;
ksubmenu_t *msubmenu1 = NULL;
ksubmenu_t *msubmenu2 = NULL;
ksubmenu_t *msubmenu3 = NULL;
ksubmenu_t *msubmenu4 = NULL;
ksubmenu_t *msubmenu5 = NULL;

char *out_id = "-";

void mainwnd_draw(void)
{
	kos_WindowRedrawStart();
	
	kos_DefineAndDrawWindow(-1, -1, 400, 300, 0x33000000 | theme.win_body, 0, "Menu test");
	kmainmenu_draw(main_menu);
	
	t_button btn = {
		.color = theme.btn_face,
		.id    = 2,
		.size.left   = 20,
		.size.top    = main_menu->top + main_menu->height + 10,
		.size.right  = 120,
		.size.bottom = main_menu->top + main_menu->height + 10 + 20,
	};
	kos_PutButton(&btn);
	
	t_label lbl = {0};
	lbl.font.color  = 0;
	lbl.font.type   = FONT_MONOSPACED | FONT_DRAW_ASCIIZ;

	lbl.position.left = 3;
	lbl.position.top  = main_menu->top + main_menu->height + 15;
	lbl.text = out_id;
	kos_PutLabel(&lbl);
	
	/*t_rect rc = {0};
	rc.right  = 400;
	rc.bottom = 300;
	
	kmenuitem_draw(item, &rc);*/
	
	kos_WindowRedrawFinish();
}

void mainwnd_onbutton(int btn_id)
{
	switch (btn_id)
	{
		case 2: {
			t_point pt = {0};
			kos_GetCursorPosByScreen(&pt);
			/*t_rect rc = {0};
			rc.left = pt.left;
			rc.top  = pt.top;*/
			ksubmenu_draw(menu, &pt);
			break;
		}
		case 3:
			out_id = "3";
			break;
		case 4:
			out_id = "4";
			break;
		case 5:
			out_id = "5";
			break;
		case 6:
			out_id = "6";
			break;
	}
}

void mainwnd_run(void)
{
	while (1)
	{
		int event = kos_WaitForEvent();
		//kmenu_dispatch_event(main_menu, event);
		switch (event)
		{
			case SYSEVENT_WNDREDRAW:
			{
				mainwnd_draw();
				break;
			}
			
			case SYSEVENT_BTNPRESS:
			{
				int btn_id = kos_GetPressedButtonId();
				if (btn_id == BUTTONID_EXIT)
					return;
				//kmainmenu_dispatch_btnpress(main_menu, btn_id);
				mainwnd_onbutton(btn_id);
				break;
			}
			case SYSEVENT_MOUSE:
			{
				kmainmenu_dispatch_cursorevent(main_menu);
				break;
			}
		}
		//menu_dispatch_event(event);
	}
}

int main(int argc, char **argv)
{
	if (!kos_HeapInit()) {
		kos_ExitApp();
	}
	
#ifdef DYNAMIC_LOAD
	t_dll_api *lib = kos_LoadLibrary("/cd2/1/projects/menu/libkmenu.obj");
	if (!lib)
		kos_ExitApp();
	
	kmenu_init = kos_GetProcAddress(lib, "kmenu_init");
	ksubmenu_new = kos_GetProcAddress(lib, "ksubmenu_new");
	ksubmenu_delete = kos_GetProcAddress(lib, "ksubmenu_delete");
	ksubmenu_draw = kos_GetProcAddress(lib, "ksubmenu_draw");
	ksubmenu_add = kos_GetProcAddress(lib, "ksubmenu_add");
	kmenuitem_new = kos_GetProcAddress(lib, "kmenuitem_new");
	kmenuitem_delete = kos_GetProcAddress(lib, "kmenuitem_delete");
	kmenuitem_draw = kos_GetProcAddress(lib, "kmenuitem_draw");
	kmenuitem_get_preffered_width = kos_GetProcAddress(lib, "kmenuitem_get_preffered_width");
	kmenuitem_get_preffered_height = kos_GetProcAddress(lib, "kmenuitem_get_preffered_height");
#endif

	kos_GetSystemColors(&theme);
	kmenu_init(&theme);
	
	menu = ksubmenu_new();
	ksubmenu_add(menu, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 3", KMENUITEM_ID(3)));
	ksubmenu_add(menu, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 4", KMENUITEM_ID(4)));
	ksubmenu_add(menu, kmenuitem_new(KMENUITEM_SEPARATOR, NULL, NULL));
	ksubmenu_add(menu, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 5", KMENUITEM_ID(5)));
	ksubmenu_add(menu, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 6", KMENUITEM_ID(6)));
	
	submenu1 = ksubmenu_new();
	ksubmenu_add(submenu1, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 3", KMENUITEM_ID(3)));
	ksubmenu_add(submenu1, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 4", KMENUITEM_ID(4)));
	ksubmenu_add(submenu1, kmenuitem_new(KMENUITEM_SEPARATOR, NULL, NULL));
	ksubmenu_add(submenu1, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 5", KMENUITEM_ID(5)));
	ksubmenu_add(submenu1, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 6", KMENUITEM_ID(6)));
	
	ksubmenu_add(menu, kmenuitem_new(KMENUITEM_SUBMENU, "submenu", submenu1));
	
	submenu2 = ksubmenu_new();
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 3", KMENUITEM_ID(3)));
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 4", KMENUITEM_ID(4)));
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_SEPARATOR, NULL, NULL));
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 5", KMENUITEM_ID(5)));
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 6", KMENUITEM_ID(6)));
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_SEPARATOR, NULL, NULL));
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 7", KMENUITEM_ID(7)));
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 8", KMENUITEM_ID(8)));
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_SEPARATOR, NULL, NULL));
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 9", KMENUITEM_ID(9)));
	ksubmenu_add(submenu2, kmenuitem_new(KMENUITEM_NORMAL, "ButtonID 10", KMENUITEM_ID(10)));
	
	ksubmenu_add(submenu1, kmenuitem_new(KMENUITEM_SUBMENU, "submenu", submenu2));
	
	
	msubmenu1 = ksubmenu_new();
	ksubmenu_add(msubmenu1, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu1, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu1, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu1, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu1, kmenuitem_new(KMENUITEM_SEPARATOR, NULL, NULL));
	ksubmenu_add(msubmenu1, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	
	msubmenu2 = ksubmenu_new();
	ksubmenu_add(msubmenu2, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu2, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu2, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu2, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu2, kmenuitem_new(KMENUITEM_SEPARATOR, NULL, NULL));
	ksubmenu_add(msubmenu2, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	
	msubmenu3 = ksubmenu_new();
	ksubmenu_add(msubmenu3, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu3, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu3, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu3, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu3, kmenuitem_new(KMENUITEM_SEPARATOR, NULL, NULL));
	ksubmenu_add(msubmenu3, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	
	msubmenu4 = ksubmenu_new();
	ksubmenu_add(msubmenu4, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu4, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu4, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu4, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu4, kmenuitem_new(KMENUITEM_SEPARATOR, NULL, NULL));
	ksubmenu_add(msubmenu4, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	
	msubmenu5 = ksubmenu_new();
	ksubmenu_add(msubmenu5, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu5, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu5, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu5, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	ksubmenu_add(msubmenu5, kmenuitem_new(KMENUITEM_SEPARATOR, NULL, NULL));
	ksubmenu_add(msubmenu5, kmenuitem_new(KMENUITEM_NORMAL, "Item", KMENUITEM_ID(100)));
	
	main_menu = ksubmenu_new();
	ksubmenu_add(main_menu, kmenuitem_new(KMENUITEM_SUBMENU, "Menu1", msubmenu1));
	ksubmenu_add(main_menu, kmenuitem_new(KMENUITEM_SUBMENU, "Menu2", msubmenu2));
	ksubmenu_add(main_menu, kmenuitem_new(KMENUITEM_SUBMENU, "Menu3", msubmenu3));
	ksubmenu_add(main_menu, kmenuitem_new(KMENUITEM_SUBMENU, "Menu4", msubmenu4));
	ksubmenu_add(main_menu, kmenuitem_new(KMENUITEM_SUBMENU, "Menu5", msubmenu5));
	
	/*item = kmenuitem_new(KMENUITEM_NORMAL, "test", NULL);
	item->is_focused = 1;
	item->width = 100;
	item->height = 20;*/
	
	mainwnd_draw();
	mainwnd_run();

	kos_ExitApp();
	return 0;
}
