#ifndef __CONSOLE_H
#define __CONSOLE_H

#include <system/api.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdint.h>

#define CON_COLOR_BLUE   0x01
#define CON_COLOR_GREEN  0x02
#define CON_COLOR_RED    0x04
#define CON_COLOR_BRIGHT 0x08
/* background color */
#define CON_BGR_BLUE    0x10
#define CON_BGR_GREEN   0x20
#define CON_BGR_RED     0x40
#define CON_BGR_BRIGHT  0x80
/* output controls */
#define CON_IGNORE_SPECIALS 0x100

#define CON_WINDOW_CLOSED 0x200

typedef int (__stdcall * con_gets2_callback)(int keycode, char** pstr, int* pn, int* ppos);

typedef struct {
	void __stdcall (*START)(int arg);
	unsigned version;

	void __stdcall (*init)(unsigned wnd_width, unsigned wnd_height, unsigned scr_width, unsigned scr_height, const char* title);
	void __stdcall (*exit)(bool bCloseWindow);
	//void __stdcall (*set_title)(const char* title);
	void __stdcall (*write_asciiz)(const char* string);
	void __stdcall (*write_string)(const char* string, unsigned length);
	int __cdecl (*printf)(const char* format, ...);
	unsigned __stdcall (*get_flags)(void);
	unsigned __stdcall (*set_flags)(unsigned new_flags);
	int __stdcall (*get_font_height)(void);
	int __stdcall (*get_cursor_height)(void);
	int __stdcall (*set_cursor_height)(int new_height);
	int __stdcall (*getch)(void);
	unsigned short __stdcall (*getch2)(void);
	int __stdcall (*kbhit)(void);
	char* __stdcall (*gets)(char* str, int n);
	char* __stdcall (*gets2)(con_gets2_callback callback, char* str, int n);
	void __stdcall (*cls)(void);
	void __stdcall (*get_cursor_pos)(int* px, int* py);
	void __stdcall (*set_cursor_pos)(int x, int y);
} t_console;

t_console * GetConsoleInstance(void);
bool LoadConsole (void);

#endif //__CONSOLE_H
