#ifndef __LIBGUI_H
#define __LIBGUI_H

typedef struct {
	void * __stdcall (*LibGUIversion)(...);
	void * __stdcall (*InitLibGUI)(...);
	void * __stdcall (*LibGUImain)(...);
	void * __stdcall (*QuitLibGUI)(...);

	void * __stdcall (*CreateWindow)(...);
	void * __stdcall (*SetWindowSizeRequest)(...);

	void * __stdcall (*PackControls)(...);
	void * __stdcall (*DestroyControl)(...);
	void * __stdcall (*SetControlSizeRequest)(...);
	void * __stdcall (*GetControlSizeX)(...);
	void * __stdcall (*GetControlSizeY)(...);
	void * __stdcall (*SetControlNewPosition)(...);
	void * __stdcall (*GetControlPositionX)(...);
	void * __stdcall (*GetControlPositionY)(...);
	void * __stdcall (*SetFocuse)(...);
	void * __stdcall (*RedrawControl)(...);
	void * __stdcall (*SpecialRedrawControl)(...);

	void * __stdcall (*SetCallbackFunction)(...);
	void * __stdcall (*BlockCallbackFunction)(...);
	void * __stdcall (*UnblockCallbackFunction)(...);

	void * __stdcall (*SetIDL_Function)(...);
	void * __stdcall (*DestroyIDL_Function)(...);

	void * __stdcall (*SetTimerCallbackForFunction)(...);
	void * __stdcall (*DestroyTimerCallbackForFunction)(...);

	void * __stdcall (*SetCallbackFunctionForEvent)(...);
	void * __stdcall (*DestroyCallbackFunctionForEvent)(...);

	void * __stdcall (*CreateButton)(...);
	void * __stdcall (*CreateButtonWithText)(...);

	void * __stdcall (*CreateProgressBar)(...);
	void * __stdcall (*SetProgressBarPulse)(...);
	void * __stdcall (*ProgressBarSetText)(...);
	void * __stdcall (*ProgressBarGetText)(...);

	void * __stdcall (*CreateHorizontalScrollBar)(...);
	void * __stdcall (*CreateVerticalScrollBar)(...);

	void * __stdcall (*CreateScrolledWindow)(...);
	void * __stdcall (*ScrolledWindowPackControls)(...);

	void * __stdcall (*CreateImage)(...);

	void * __stdcall (*CreateText)(...);
	void * __stdcall (*TextBackgroundOn)(...);
	void * __stdcall (*TextBackgroundOff)(...);

	void * __stdcall (*LoadFont)(...);
	void * __stdcall (*FreeFont)(...);
} t_libGUI;

extern t_libGUI libGUI;

bool LoadLibGUI(void);

#endif //__LIBGUI_H
