#ifndef __LIBTTF_H
#define __LIBTTF_H

#include <stdbool.h>
#include <stddef.h>

typedef struct stbtt_fontinfo
{
   void           * userdata;
   unsigned char  * data;              // pointer to .ttf file
   int              fontstart;         // offset of start of font

   int numGlyphs;                     // number of glyphs, needed for range checking

   int loca,head,glyf,hhea,hmtx,kern; // table locations as offset from start of .ttf
   int index_map;                     // a cmap mapping for our chosen character encoding
   int indexToLocFormat;              // format needed to map from glyph index to glyph
} stbtt_fontinfo;

typedef struct {
	int __stdcall (*START)(void);
	int __stdcall (*version_major)(void);
	int __stdcall (*version_minor)(void);
	int __stdcall (*truetype)(char *str, stbtt_fontinfo *fontinfo, char *screen1, size_t width, size_t height);
	int __stdcall (*get_length)(char *str, stbtt_fontinfo *fontinfo, size_t height, size_t max_len);
	int __stdcall (*get_width)(char *str, stbtt_fontinfo *fontinfo, size_t height);
	int __stdcall (*text_out)(short *str, stbtt_fontinfo *fontinfo, size_t height, unsigned color, size_t back_color, int x, int y);
	void*  __stdcall (*text_out_mem)(short *str, stbtt_fontinfo *fontinfo, size_t height, unsigned color, unsigned back_color);
	int __stdcall (*init_font)(stbtt_fontinfo *fontinfo, void *fontData);
} t_libttf;

extern t_libttf libttf;

bool LoadLibTTF(void);

#endif // __LIBTTF_H
