#ifndef __LIBINI_H
#define __LIBINI_H

#include <system/api.h>

typedef int (__stdcall *t_libini_enum_sec_callback)(const char *file_name, const char *section_name);
typedef int (__stdcall *t_libini_enum_keys_callback)(
	const char *file_name, 
	const char *section_name, 
	const char *key_name, 
	const char *key_value
);

typedef struct {
	void __stdcall (*init)(void);
	unsigned version;
	int __stdcall (*enum_sections)(char *file_name, t_libini_enum_sec_callback *callback);
	int __stdcall (*enum_keys)(char *file_name, char *section_name, t_libini_enum_keys_callback *callback);
	int __stdcall (*get_str)(char *file_name, char *section_name, char *key_name, char *buffer, size_t buf_len, char *default_value);
	int __stdcall (*get_int)(char *file_name, char *section_name, char *key_name, int default_value);
	int __stdcall (*get_color)(char *file_name, char *section_name, char *key_name, int default_value);
	int __stdcall (*set_str)(char *file_name, char *section_name, char *key_name, char *buffer, size_t buf_len);
	int __stdcall (*set_int)(char *file_name, char *section_name, char *key_name, int value);
	int __stdcall (*set_color)(char *file_name, char *section_name, char *key_name, int value);
	int __stdcall (*get_shortcut)(char *file_name, char *section_name, char *key_name, unsigned default_value, unsigned *_modifiers);
	int __stdcall (*del_section)(char *file_name, char *section_name);
} t_libini;

extern t_libini libini;

bool LoadLibIni(void);

#endif // __LIBINI_H
