#include <stdlib.h>
#include <string.h>
#include <system/api.h>

#define BUFSIZE (sizeof(long) * 8 + 1)

char *ltoa(long N, char *str, int base)
{
	register int i = 2;
	long uarg;
	char *tail, *head = str, buf[BUFSIZE];

	if (36 < base || 2 > base)
		base = 10;                    /* can only use 0-9, A-Z        */
	tail = &buf[BUFSIZE - 1];           /* last character position      */
	*tail-- = '\0';

	if (10 == base && N < 0L)
	{
		*head++ = '-';
		uarg    = -N;
	}
	else
		uarg = N;

	if (uarg)
	{
		for (i = 1; uarg; ++i)
		{
			long quot = uarg/base;
			long rem  = uarg % base;
			*tail-- = (char)(rem + ((9L < rem) ? ('A' - 10L) : '0'));
			uarg    = quot;
		}
	}
	else
		*tail-- = '0';

	memcpy(head, ++tail, i);
	return str;
}

void *malloc(size_t size)
{
	return kos_HeapAlloc(size);
}

void free(void *ptr)
{
	kos_HeapFree(ptr);
}

void *calloc(size_t nmemb, size_t size)
{
	void *mem = kos_HeapAlloc(nmemb*size);
	if (!mem)
		return NULL;
	memset(mem, 0, nmemb*size);
	return mem;
}

void *realloc(void *ptr, size_t size)
{
	return kos_HeapRealloc(ptr, size);
}

static int rand_seed;

void srand (unsigned int seed)
{
	rand_seed = seed;
}

int rand (void)
{
	return (((rand_seed = rand_seed * 214013L + 2531011L) >> 16) & 0x7fff);
}
