#include <system/console.h>

static t_console Console = {0};

bool LoadConsole (void)
{
	t_dll_api *hConsole = kos_LoadLibrary("/sys/lib/console.obj");
	if (!hConsole) return 0;
	Console.START          = kos_GetProcAddress(hConsole, "START");
	Console.version        = (unsigned)kos_GetProcAddress(hConsole, "version");
	if (!Console.START || !Console.version)
		return 0;

	Console.init           = kos_GetProcAddress(hConsole, "con_init");
	Console.exit           = kos_GetProcAddress(hConsole, "con_exit");
	//Console.set_title      = kos_GetProcAddress(hConsole, "con_set_title");
	Console.write_asciiz   = kos_GetProcAddress(hConsole, "con_write_asciiz");
	Console.write_string   = kos_GetProcAddress(hConsole, "con_write_string");
	Console.printf         = kos_GetProcAddress(hConsole, "con_printf");
	Console.get_flags      = kos_GetProcAddress(hConsole, "con_get_flags");
	Console.set_flags      = kos_GetProcAddress(hConsole, "con_set_flags");
	Console.get_font_height = kos_GetProcAddress(hConsole, "con_get_font_height");
	Console.get_cursor_height = kos_GetProcAddress(hConsole, "con_get_cursor_height");
	Console.set_cursor_height = kos_GetProcAddress(hConsole, "con_set_cursor_height");
	Console.getch          = kos_GetProcAddress(hConsole, "con_getch");
	Console.getch2         = kos_GetProcAddress(hConsole, "con_getch2");
	Console.kbhit          = kos_GetProcAddress(hConsole, "con_kbhit");
	Console.gets           = kos_GetProcAddress(hConsole, "con_gets");
	Console.gets2          = kos_GetProcAddress(hConsole, "con_gets2");
	Console.cls            = kos_GetProcAddress(hConsole, "con_cls");
	Console.get_cursor_pos = kos_GetProcAddress(hConsole, "con_get_cursor_pos");
	Console.set_cursor_pos = kos_GetProcAddress(hConsole, "con_set_cursor_pos");
	if ((Console.init &&
		Console.exit &&
		//Console.set_title &&
		Console.write_asciiz &&
		Console.write_string &&
		Console.printf &&
		Console.get_flags &&
		Console.set_flags &&
		Console.get_font_height &&
		Console.get_cursor_height &&
		Console.set_cursor_height &&
		Console.getch &&
		Console.getch2 &&
		Console.kbhit &&
		Console.gets &&
		Console.gets2 &&
		Console.cls &&
		Console.get_cursor_pos &&
		Console.set_cursor_pos
		) == 0)
		return 0;
	
	Console.START(1);
	return 1;
}

t_console * GetConsoleInstance(void)
{
	if (!Console.START)
		if (LoadConsole())
			return &Console;
		else
			return NULL;
	else
		return &Console;
}
