#include <system/api.h>
#include <system/gui/libttf.h>

t_libttf libttf = {0};

bool InitLibTTF(void)
{
	if (libttf.START)
		return true;

	t_dll_api *hLib = kos_LoadLibrary("/sys/lib/truetype.obj");
	if (!hLib)
		return false;
	libttf.START          = kos_GetProcAddress(hLib, "lib_init");
	libttf.version_major  = kos_GetProcAddress(hLib, "version");
	libttf.version_minor  = kos_GetProcAddress(hLib, "version_min");

	if (!libttf.START || !libttf.version_major || libttf.version_minor)
	{
		libttf.START = NULL;
		return false;
	}
	
	libttf.truetype       = kos_GetProcAddress(hLib, "truetype");
	libttf.get_length     = kos_GetProcAddress(hLib, "get_length");
	libttf.get_width      = kos_GetProcAddress(hLib, "get_width");
	libttf.text_out       = kos_GetProcAddress(hLib, "text_out");
	libttf.text_out_mem   = kos_GetProcAddress(hLib, "text_out_mem");
	libttf.init_font      = kos_GetProcAddress(hLib, "init_font");
	
	if ((
		libttf.truetype     &&
		libttf.get_length   &&
		libttf.get_width    &&
		libttf.text_out     &&
		libttf.text_out_mem &&
		libttf.init_font) == 0
	)
	{
		libttf.START    = NULL;
		return false;
	}
	return libttf.START();
}
