#include <system/libini.h>

t_libini libini = {0};

static void * __stdcall stdcall_malloc(size_t len)
{
	void *retval = NULL;
	_asm {
		pusha
	}
	kos_HeapAlloc(len);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

static int __stdcall stdcall_free(void *mem)
{
	int retval = 0;
	_asm {
		pusha
	}
	kos_HeapFree(mem);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

static void *__stdcall stdcall_realloc(void *mem, size_t len)
{
	void *retval = NULL;
	_asm {
		pusha
	}
	kos_HeapRealloc(mem, len);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

static t_dll_api * __stdcall stdcall_loaddll(char *dllname)
{
	t_dll_api *retval = NULL;
	_asm {
		pusha
	}
	kos_LoadLibrary(dllname);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

bool LoadLibIni(void)
{
	unsigned retval = 0;
	if (libini.init && libini.version)
		return true;

	t_dll_api *hLib = kos_LoadLibrary("/sys/lib/libini.obj");
	if (!hLib)
		return false;

	libini.init          = kos_GetProcAddress(hLib, "lib_init");
	libini.version       = (unsigned)kos_GetProcAddress(hLib, "version");

	if (!libini.init || !libini.version)
		return false;
		
	libini.enum_sections = kos_GetProcAddress(hLib, "ini_enum_sections");
	libini.enum_keys     = kos_GetProcAddress(hLib, "ini_enum_keys");
	libini.get_str       = kos_GetProcAddress(hLib, "ini_get_str");
	libini.get_int       = kos_GetProcAddress(hLib, "ini_get_int");
	libini.get_color     = kos_GetProcAddress(hLib, "ini_get_color");
	libini.set_str       = kos_GetProcAddress(hLib, "ini_set_str");
	libini.set_int       = kos_GetProcAddress(hLib, "ini_set_int");
	libini.set_color     = kos_GetProcAddress(hLib, "ini_set_color");
	libini.get_shortcut  = kos_GetProcAddress(hLib, "ini_get_shortcut");
	libini.del_section   = kos_GetProcAddress(hLib, "ini_del_section");
	
	if ((
		libini.enum_sections &&
		libini.enum_keys     &&
		libini.get_str       &&
		libini.get_int       &&
		libini.get_color     &&
		libini.set_str       &&
		libini.set_int       &&
		libini.set_color     &&
		libini.get_shortcut  &&
		libini.del_section
	) == 0)
	{
		libini.init    = NULL;
		libini.version = 0;
		return false;
	}
	_asm {
		pusha
		mov eax, stdcall_malloc
		mov ebx, stdcall_free
		mov ecx, stdcall_realloc
		mov edx, stdcall_loaddll
		call [libini.init]
		mov [retval], eax
		popa
	}
	return true;
}
