#include <system/libio.h>

t_libio libio = {0};

static void * __stdcall stdcall_malloc(size_t len)
{
	void *retval = NULL;
	_asm {
		pusha
	}
	kos_HeapAlloc(len);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

static int __stdcall stdcall_free(void *mem)
{
	int retval = 0;
	_asm {
		pusha
	}
	kos_HeapFree(mem);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

static void *__stdcall stdcall_realloc(void *mem, size_t len)
{
	void *retval = NULL;
	_asm {
		pusha
	}
	kos_HeapRealloc(mem, len);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

static t_dll_api * __stdcall stdcall_loaddll(char *dllname)
{
	t_dll_api *retval = NULL;
	_asm {
		pusha
	}
	kos_LoadLibrary(dllname);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

bool LoadLibIO(void)
{
	unsigned retval = 0;
	if (libio.init && libio.version)
		return true;

	t_dll_api *hLib = kos_LoadLibrary("/sys/lib/libio.obj");
	if (!hLib)
		return false;
	libio.init          = kos_GetProcAddress(hLib, "lib_init");
	libio.version       = (unsigned)kos_GetProcAddress(hLib, "version");

	if (!libio.init || !libio.version)
		return false;

	libio.find_first = kos_GetProcAddress(hLib, "file_find_first");
	libio.find_next  = kos_GetProcAddress(hLib, "file_find_next");
	libio.find_close = kos_GetProcAddress(hLib, "file_find_close");
	libio.size       = kos_GetProcAddress(hLib, "file_size");
	libio.open       = kos_GetProcAddress(hLib, "file_open");
	libio.read       = kos_GetProcAddress(hLib, "file_read");
	libio.write      = kos_GetProcAddress(hLib, "file_write");
	libio.seek       = kos_GetProcAddress(hLib, "file_seek");
	libio.tell       = kos_GetProcAddress(hLib, "file_tell");
	libio.iseof      = kos_GetProcAddress(hLib, "file_iseof");
	libio.seteof     = kos_GetProcAddress(hLib, "file_seteof");
	libio.truncate   = kos_GetProcAddress(hLib, "file_truncate");
	libio.close      = kos_GetProcAddress(hLib, "file_close");
	
	if ((libio.find_first &&
	     libio.find_next &&
	     libio.find_close &&
	     libio.size &&
	     libio.open &&
	     libio.read &&
	     libio.write &&
	     libio.seek &&
	     libio.tell &&
	     libio.iseof &&
	     libio.seteof &&
	     libio.truncate &&
	     libio.close) == 0
	)
	{
		libio.init    = NULL;
		libio.version = 0;
		return false;
	}
	_asm {
		pusha
		mov eax, stdcall_malloc
		mov ebx, stdcall_free
		mov ecx, stdcall_realloc
		mov edx, stdcall_loaddll
		call [libio.init]
		mov [retval], eax
		popa
	}
	return true;
}
