#include <system/api.h>
#include <system/net/libhttp.h>

#include <string.h>

t_libhttp libhttp = {0};

static void * __stdcall stdcall_malloc(size_t len)
{
	void *retval = NULL;
	_asm {
		pusha
	}
	kos_HeapAlloc(len);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

static int __stdcall stdcall_free(void *mem)
{
	int retval = 0;
	_asm {
		pusha
	}
	kos_HeapFree(mem);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

static void *__stdcall stdcall_realloc(void *mem, size_t len)
{
	void *retval = NULL;
	_asm {
		pusha
	}
	kos_HeapRealloc(mem, len);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

static t_dll_api * __stdcall stdcall_loaddll(char *dllname)
{
	t_dll_api *retval = NULL;
	_asm {
		pusha
	}
	kos_LoadLibrary(dllname);
	_asm {
		mov [retval], eax
		popa
	}
	return retval;
}

void HttpGetPostValue(char *lpPostData, char *lpArgName, char **lppArgValue, size_t *lpArgValueSize)
{
	char *lpTmpPostData; // ebp@1
	char *lpTmpArgName;  // eax@1 MAPDST
	char *lpNextArg;	 // esi@4
	char *lpValuePos;		   // eax@12
	
	if (!lpPostData || !lpArgName || !lppArgValue || !lpArgValueSize)
		return;
	
	*lppArgValue = 0;
	*lpArgValueSize = 0;

	lpTmpPostData = kos_HeapAlloc(strlen(lpPostData) + 1);
	lpTmpArgName = kos_HeapAlloc(strlen(lpArgName) + 2);

	if (!lpTmpPostData || !lpTmpArgName)
	{
		goto safe_exit;
	}

	if (strstr(lpPostData, "&"))
	{
		strcpy(lpTmpPostData, lpPostData);
		strcpy(lpTmpArgName, lpArgName);
		strcat(lpTmpArgName, "=");
		
		lpNextArg = strtok(lpTmpPostData, "&");
		if (lpNextArg)
		{
			while (1)
			{
				if (!strnicmp(lpNextArg, lpTmpArgName, strlen(lpTmpArgName)))
					break;

				lpNextArg = strtok(lpNextArg, "&");
				if (!lpNextArg)
					goto safe_exit;
			}
			lpValuePos = strstr(lpNextArg, "=");
			if (lpValuePos)
			{
				lpValuePos++;
				if (strlen(lpValuePos) > 0)
				{
					*lppArgValue = kos_HeapAlloc(strlen(lpValuePos) + 1);
					if (*lppArgValue)
					{
						memset(*lppArgValue, 0, strlen(lpValuePos) + 1);
						strcpy(*lppArgValue, lpValuePos);
						(*lppArgValue)[strlen(lpValuePos)] = 0;
						*lpArgValueSize = strlen(lpValuePos);
						kos_HeapFree(lpTmpArgName);
						kos_HeapFree(lpTmpPostData);
						return;
					}
				}
			}
		}
	}
safe_exit:
	if (lpTmpPostData)
		kos_HeapFree(lpTmpPostData);
	if (lpTmpArgName)
		kos_HeapFree(lpTmpArgName);
}

bool LoadLibHTTP(void)
{
	unsigned retval = 0;
	if (libhttp.init && libhttp.version)
		return true;

	t_dll_api *hLib = kos_LoadLibrary("/sys/lib/http.obj");
	if (!hLib)
		return false;
	libhttp.init	   = kos_GetProcAddress(hLib, "lib_init");
	libhttp.version	= (unsigned)kos_GetProcAddress(hLib, "version");

	if (!libhttp.init || !libhttp.version)
		return false;

	libhttp.get		= kos_GetProcAddress(hLib, "get");
	libhttp.head	   = kos_GetProcAddress(hLib, "head");
	libhttp.post	   = kos_GetProcAddress(hLib, "post");
	libhttp.find_header_field = kos_GetProcAddress(hLib, "find_header_field");
	libhttp.process	= kos_GetProcAddress(hLib, "process");
	libhttp.send	   = kos_GetProcAddress(hLib, "send");
	libhttp.receive	= kos_GetProcAddress(hLib, "receive");
	libhttp.disconnect = kos_GetProcAddress(hLib, "disconnect");
	libhttp.free	   = kos_GetProcAddress(hLib, "free");
	libhttp.stop	   = kos_GetProcAddress(hLib, "stop");
	libhttp.escape	 = kos_GetProcAddress(hLib, "escape");
	libhttp.unescape   = kos_GetProcAddress(hLib, "unescape");
	
	if ((
		libhttp.get &&
		libhttp.head &&
		libhttp.post &&
		libhttp.find_header_field &&
		libhttp.process &&
		libhttp.send &&
		libhttp.receive &&
		libhttp.disconnect &&
		libhttp.free &&
		libhttp.stop &&
		libhttp.escape &&
		libhttp.unescape
	) == 0)
	{
		libhttp.init	= NULL;
		libhttp.version = 0;
		return false;
	}
	_asm {
		pusha
		mov eax, stdcall_malloc
		mov ebx, stdcall_free
		mov ecx, stdcall_realloc
		mov edx, stdcall_loaddll
		call [libhttp.init]
		mov [retval], eax
		popa
	}
	return (retval == 0);
}
